include     WriteLen\WriteLen.inc

.data

DllName     db 'Console.dll',0
func        db 'StdOut',0
message     db 'StdOut called from Console.dll',13,10,0
filename    db 'Testdll.exe',0
readfail    db 'cannot read Testdll.exe',0
writefail   db 'cannot write the destination file',0
mallocfail  db 'memory allocation failure',0
loadlibfail db 'cannot load the DLL',0
getprocfail db 'cannot call StdOut exported by Console.dll',0
szNULL      db 0

.data?

hReadFile   dd ?
hWriteFile  dd ?
bBytes      dd ?
hInst       dd ?
fSize       dd ?
pMem        dd ?

.code

start:

    invoke  CreateFile,ADDR filename,GENERIC_READ,\
            0,0,OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,0
    mov     edi,OFFSET readfail
    cmp     eax,INVALID_HANDLE_VALUE
    je      _exit
        
    mov     hReadFile,eax
    invoke  SetFilePointer,eax,-SIZEOF DWORD,0,FILE_END
    invoke  ReadFile,hReadFile,ADDR fSize,SIZEOF DWORD,ADDR bBytes,0
    test    eax,eax
    jz      finish2

    neg     fSize
    invoke  SetFilePointer,hReadFile,fSize,0,FILE_END
    neg     fSize
    sub     fSize,SIZEOF DWORD
    invoke  VirtualAlloc,0,fSize,MEM_COMMIT,PAGE_READWRITE
    mov     edi,OFFSET mallocfail
    test    eax,eax
    jz      finish2
    
    mov     pMem,eax
    invoke  ReadFile,hReadFile,eax,fSize,ADDR bBytes,0
    mov     edi,OFFSET readfail
    test    eax,eax
    jz      finish

    invoke  CreateFile,ADDR DllName,GENERIC_WRITE,0,0,\
            CREATE_ALWAYS,FILE_ATTRIBUTE_ARCHIVE,0
    mov     edi,OFFSET readfail
    cmp     eax,INVALID_HANDLE_VALUE
    je      finish
    
    mov     hWriteFile,eax
    invoke  WriteFile,eax,pMem,fSize,ADDR bBytes,0
    mov     esi,eax
    invoke  CloseHandle,hWriteFile
    mov     edi,OFFSET writefail
    test    esi,esi
    jz      finish

    invoke  LoadLibrary,ADDR DllName
    mov     edi,OFFSET loadlibfail
    test    eax,eax
    jz      finish
    
    mov     hInst,eax
    invoke  GetProcAddress,eax,ADDR func
    mov     edi,OFFSET getprocfail
    test    eax,eax
    jz      finish

    invoke  pr1 PTR eax,ADDR message
    invoke  FreeLibrary,hInst
    mov     edi,OFFSET szNULL

finish: 

    invoke  VirtualFree,pMem,0,MEM_RELEASE

finish2:

    invoke  CloseHandle,hReadFile
    
_exit:

    invoke  StdOut,edi
    invoke  ExitProcess,0
    
END start

