include     WriteLen.inc

ParseCmdLine PROTO :DWORD

.data

welcome     db 'WriteLen V1.0 - tool to write the file size increased by 4 to',13,10
            db 'the end of a binary file',13,10,13,10
            db 'Usage : WriteLen filename.ext',13,10,0
success     db 'file modified successfully',13,10,0
readfail    db 'cannot read the file',0
writefail   db 'cannot write to the file',0
mallocfail  db 'memory allocation failure',0

.data?

cmdline     dd 512 dup(?)
hFile       dd ?
fSize       dd ?
bWritten    dd ?

.code

start:

    mov     esi,OFFSET cmdline
    invoke  ParseCmdLine,esi
    mov     edi,OFFSET welcome
    cmp     eax,2
    jne     _exit
   
    invoke  CreateFile,DWORD PTR [esi+4],GENERIC_READ or GENERIC_WRITE,\
            0,0,OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,0
    mov     edi,OFFSET readfail            
    cmp     eax,INVALID_HANDLE_VALUE
    je      _exit

    mov     hFile,eax
    invoke  SetFilePointer,eax,0,0,FILE_END
    add     eax,SIZEOF DWORD
    mov     fSize,eax
    invoke  WriteFile,hFile,ADDR fSize,SIZEOF DWORD,ADDR bWritten,0
    mov     edi,OFFSET writefail
    test    eax,eax
    jz      finish
    mov     edi,OFFSET success

finish:

    invoke  CloseHandle,hFile
    
_exit:

    invoke  StdOut,edi
    invoke  ExitProcess,0

END start


